#-----------------------------------------------------------------
# index.dat
# =========
#  0 ~ 29 (30byte) header
# 30 ~ 33 ( 4byte)   (integer)
# 34 ~ 37 ( 4byte)   (integer)
# 38 ~ 45 ( 8byte) 
# 45 ~    ( 4byte)  Ʈ(  ŭ ) long integer
#-----------------------------------------------------------------
# content.dat
# ===========
#  0 ~ 29 (30byte) header
# 30 ~             
# ..............................
#  +0 ~ +3 ( 4byte)  
#  +4 ~             
#          ( 4byte)  
#                   
#-----------------------------------------------------------------

sub Get_TotalCont
#********************************************************************
#  ϱ
#--------------------------------------------------------------------
{
	fOpen( Handle, "$DB_PATH/index.dat", "br" );
	$TotalCont = fGet( Handle, 30, 4, "I" );
	close( Handle );
}


sub Get_TotalZero
#********************************************************************
#  ϱ
#--------------------------------------------------------------------
{
	fOpen( Handle, "$DB_PATH/index.dat", "br" );
	my $tTotalZero = fGet( Handle, 34, 4, "I" );
	close( Handle );
	return $tTotalZero;
}


sub Get_BinFile #( Page, Option )
#********************************************************************
#
#--------------------------------------------------------------------
{
	my( $Te );
	my( $Cont1, $Cont2 );

	fOpen( Handle, "$DB_PATH/index.dat", "br" );
	my $Offset = fGet( Handle, $_[0] * 5 + 40, 4, "L" );
	my $Depth  = fGet( Handle, -1, 1, "" );
	close( Handle );

	fOpen( Handle, "$DB_PATH/content.dat", "br" );
	seek ( Handle, $Offset, 0 );
	read ( Handle, $Te, 4 ); read( Handle, $Cont1, unpack( "I", $Te ));
	read ( Handle, $Te, 4 ); read( Handle, $Cont2, unpack( "I", $Te )) unless( $_[1] );
	close( Handle );

	if( $_[1] ) { return ord($Depth), $Cont1; }
	else { return ord($Depth), $Cont1, $Cont2; }
}


sub Add_BinFile #( 1, 2 )
#********************************************************************
#
#--------------------------------------------------------------------
{
	my( $Te, $T1 );
	my $IdxHeader = "bluebod binfile index 1.00" . chr(27);
	my $DatHeader = "bluebod binfile content 1.00" . chr(27);
	my $DatFileSize = -s "$DB_PATH/content.dat";

	fOpen( Handle1, "$DB_PATH/index.dat", "b+r" );
	fOpen( Handle2, "$DB_PATH/content.dat", "b+r" );

	#-   
	$TotalCont = fGet( Handle1, 30, 4, "I" );
	$TotalZero = fGet( Handle1, -1, 4, "I" );

	#- ε Ʈ 
	fPut( Handle1, $TotalCont * 5 + 45, $DatFileSize, "L" );
	fPut( Handle1, -1, chr(0), "" );

	#- ǵ 
	seek( Handle2, $DatFileSize, 0 );
	print Handle2 pack( "I", length( $_[0] )); print Handle2 $_[0];
	print Handle2 pack( "I", length( $_[1] )); print Handle2 $_[1];

	#-     ϱ
	fPut( Handle1, 30, ++$TotalCont, "I" );
	fPut( Handle1, -1, ++$TotalZero, "I" );

	fClose( Handle1, 1 );
	fClose( Handle2, 1 );
}


sub Del_BinFile #(  )
#********************************************************************
#
#--------------------------------------------------------------------
{
	my $Te;
	my $DelLine = $_[0];
	my $DelFileSize = -s "$DB_PATH/delline.dat";

	fOpen( FP1, "$DB_PATH/index.dat", "b+r" );
	fOpen( FP3, "$DB_PATH/delline.dat", "b+r" );

	#-   Depth 
	my $Offset = fGet( FP1, $DelLine * 5 + 40, 4, "L" );
	my $tDepth = fGet( FP1, -1, 1, "" );

	#-   
	my $TotalDel  = fGet( FP3, 30, 4, "I" );
	my $TotalCont = fGet( FP1, 30, 4, "I" );
	my $TotalZero = fGet( FP1, -1, 4, "I" );

	#- ҵ    ϱ
	fPut( FP3, $TotalDel * 4 + 34, $Offset, "L" );
	fPut( FP3, 30, ++$TotalDel , "I" );
	fPut( FP1, 30, --$TotalCont, "I" );
	fPut( FP1, -1, --$TotalZero, "I" ) if( !ord($tDepth) );

	#- ε 
	for( $DelLine..$TotalCont )
	{
		seek( FP1, $_ * 5 + 45, 0 ); read( FP1, $Te, 5 );
		seek( FP1, $_ * 5 + 40, 0 ); print FP1 $Te;
	}

	fClose( FP1, 1 );
	fClose( FP3, 1 );
}


sub Ins_BinFile #( 1, 2,  )
#********************************************************************
#
#--------------------------------------------------------------------
{
	my $Te;
	my $InsLine = $_[2];
	my $DatFileSize = -s "$DB_PATH/content.dat";

	fOpen( FP1, "$DB_PATH/index.dat", "b+r" );
	fOpen( FP2, "$DB_PATH/content.dat", "b+r" );

	#-    
	my $TotalCont = fGet( FP1, 30, 4, "I" );
	my $TotalZero = fGet( FP1, -1, 4, "I" );

	#- ε 
	for( my $i=$TotalCont; $i>=$InsLine; $i-- )
	{
		seek( FP1, $i * 5 + 40, 0 ); read( FP1, $Te, 5 );
		seek( FP1, $i * 5 + 45, 0 ); print FP1 $Te;
	}

	#- ε  
	fPut( FP1, $InsLine * 5 + 40, $DatFileSize, "L" );
	fPut( FP1, -1, chr($CMD{'depth'}), "" );

	#- ǵ 
	seek( FP2, $DatFileSize, 0 );
	print FP2 pack( "I", length( $_[0] )); print FP2 $_[0];
	print FP2 pack( "I", length( $_[1] )); print FP2 $_[1];

	#-     ϱ
	fPut( FP1, 30, ++$TotalCont, "I" );
	fPut( FP1, -1, ++$TotalZero, "I" ) if( !$CMD{'depth'} );

	fClose( FP1, 1 );
	fClose( FP2, 1 );
}


sub Edit_BinFile #( 1, 2,  )
#********************************************************************
#  
#--------------------------------------------------------------------
{
    my $Te;
	my $Len;
	my $TotalDel;
	my $DatFileSize = -s "$DB_PATH/content.dat";

	fOpen( FP1, "$DB_PATH/index.dat", "b+r" );
	fOpen( FP2, "$DB_PATH/content.dat", "b+r" );
	fOpen( FP3, "$DB_PATH/delline.dat", "b+r" );

	#-   Depth 
	my $Offset = fGet( FP1, $_[2] * 5 + 40, 4, "L" );
	my $tDepth = fGet( FP1, -1, 1, "" );

	#-    
	my $TotalCont = fGet( FP1, 30, 4, "I" );
	my $TotalZero = fGet( FP1, -1, 4, "I" );

	$Len  = fGet( FP2, $Offset, 4, "I" );
	$Len += fGet( FP2, $Offset + $Len + 4, 4, "I" );

	if( $Len < length($_[0]) + length($_[1]) )
	{
		$TotalDel = fGet( FP3, 30, 4, "I" );
		fPut( FP3, $TotalDel * 4 + 34, $Offset, "L" );
		fPut( FP3, 30, ++$TotalDel, "I" );

		$Offset = $DatFileSize;
		fPut( FP1, $_[2] * 5 + 40, $Offset, "L" );
	}

	#- ǵ 
	seek( FP2, $Offset, 0 );
	print FP2 pack( "I", length($_[0]) ); print FP2 $_[0];
	print FP2 pack( "I", length($_[1]) ); print FP2 $_[1];

	fClose( FP1, 1 );
	fClose( FP2, 1 );
	fClose( FP3, 1 );
}


sub Make_BinFile
#********************************************************************
#
#--------------------------------------------------------------------
{
	my $IdxHeader = "bluebod binfile index 1.00" . chr(27);
	my $DatHeader = "bluebod binfile content 1.00" . chr(27);
	my $DelHeader = "bluebod binfile delline 1.00" . chr(27);
	my $CntHeader = "bluebod Date-Count file 1.00" . chr(27);

	fOpen( Handle, "$DB_PATH/index.dat", "bw" );
	print Handle pack( "a30", $IdxHeader );
	print Handle pack( "I4", 0, 0, 0, 0 );
	fClose( Handle, 1 );

	fOpen( Handle, "$DB_PATH/content.dat", "bw" );
	print Handle pack( "a30", $DatHeader );
	fClose( Handle, 1 );

	fOpen( Handle, "$DB_PATH/delline.dat", "bw" );
	print Handle pack( "a30", $DelHeader );
	print Handle pack( "I", 0 );
	fClose( Handle, 1 );

	fOpen( FP1, "$DB_PATH/count.dat", "bw" );
	print FP1 pack( "a30", $CntHeader );
	print FP1 pack( "S", substr( &GetDate(time), 0, 4 ));
	print FP1 pack( "I", time );
	print FP1 pack( "a1724", "" );
	fClose( FP1, 1 );
}


#--------------------------------------------------------------------
sub Make_DelFile
{
	my $DelHeader = "bluebod binfile dellien 1.00" . chr(27);
	fOpen( Handle, "$DB_PATH/delline.dat", "bw" );
	print Handle pack( "a30", $DelHeader );
	print Handle pack( "I", 0 );
	fClose( Handle, 1 );
}


#--------------------------------------------------------------------
sub Get_DelInfo
{
	my $Cont1;
	my $Cont2;

	fOpen( FP2, "$DB_PATH/content.dat", "br" );
	fOpen( FP3, "$DB_PATH/delline.dat", "br" );

	my $TotalDel = fGet( FP3, 30, 4, "I" );

	print "<div align=left>\n";
	for( 1..$TotalDel )
	{
		my $Te = fGet( FP3, $_ * 4 + 30, 4, "L" );

		print "ȣ: $_<br>\n";
		print "ɼ: $Te<br>\n";

		seek( FP2, $Te, 0 );
		read( FP2, $Te, 4 ); read( FP2, $Cont1, unpack( "I", $Te ));
		read( FP2, $Te, 4 ); read( FP2, $Cont2, unpack( "I", $Te )); $Cont2 =~ s/<!--/&lt;--/g;

		print "Info: $Cont1<br>\n";
		print "Cont: $Cont2<br>\n";
		print "<hr size=1>\n";
	}
	print "</div>\n\n";

	close( FP2 );
	close( FP3 );
}


#-----------------------------------------------------------------
return 1;
